#ifndef	BOTACTOR_H
#define	BOTACTOR_H

#include	"genesis.h"

#pragma warning( disable : 4068 )

#pragma GE_Type("BotActor.bmp")
typedef struct BotActorStart BotActorStart;

#pragma GE_Type("BotActor.bmp")
typedef struct BotActorStart {
#pragma GE_Published

	geVec3d		origin;
	geBoolean   Respawn;
	geBoolean	Retreat;
	geBoolean   IgnoreTurrets;
	int			SkillLevel;
	int			EnemyNumber;
	geBoolean   WeaponShredder;
	geBoolean   WeaponGrenades;
	geBoolean   WeaponRockets;
	int			WeaponShredderA;
	int			WeaponGrenadesA;
	int			WeaponRocketsA;
	int			HealthLevel;
	char		*CommandsFile;
	#pragma GE_DefaultValue(CommandsFile, "")
	#pragma GE_Documentation(CommandsFile, "Commands file")

	#pragma GE_DefaultValue(SkillLevel, "5")
	#pragma GE_Documentation(SkillLevel, "From 1 to 10 - Higher is less difficult.")

	#pragma GE_DefaultValue(Respawn, "False")
	#pragma GE_Documentation(Respawn, "Respawn actor after death.")

	#pragma GE_DefaultValue(Retreat, "False")
	#pragma GE_Documentation(Retreat, "Do you want the bot to be able to retreat.")

	#pragma GE_DefaultValue(IgnoreTurrets, "True")
	#pragma GE_Documentation(IgnoreTurrets, "Actor will not shoot at turrets if True.")

	#pragma GE_DefaultValue(EnemyNumber, "0")
	#pragma GE_Documentation(EnemyNumber, "From 0 to 8 (0=Random(1-6), 1-8=Specific enemy number.")

	#pragma GE_DefaultValue(WeaponShredder, "False")
	#pragma GE_Documentation(WeaponShredder, "Weapon Shredder in the bot's inventory.")

	#pragma GE_DefaultValue(WeaponShredderA, "50")
	#pragma GE_Documentation(WeaponShredderA, "Weapon Shredder Ammo.")

	#pragma GE_DefaultValue(WeaponGrenades, "False")
	#pragma GE_Documentation(WeaponGrenades, "Weapon Grenades in the bot's inventory.")

	#pragma GE_DefaultValue(WeaponGrenadesA, "20")
	#pragma GE_Documentation(WeaponGrenadesA, "Weapon Grenades Ammo.")

	#pragma GE_DefaultValue(WeaponRockets, "False")
	#pragma GE_Documentation(WeaponRockets, "Weapon Rockets in the bot's inventory.")

	#pragma GE_DefaultValue(WeaponRocketsA, "15")
	#pragma GE_Documentation(WeaponRocketsA, "Weapon Rockets Ammo.")

	#pragma GE_DefaultValue(HealthLevel, "50")
	#pragma GE_Documentation(HealthLevel, "From 1 to 100 - Bot level health.")

#pragma GE_Private

	char		*Ptr;

#pragma GE_Origin(origin)
} BotActorStart;



#pragma GE_Type("BlockActor.bmp")
typedef struct BlockActor BlockActor;

#pragma GE_Type("BlockActor.bmp")
typedef struct BlockActor {
#pragma GE_Published

geVec3d		Origin;
geWorld_Model *Model;

#pragma GE_Documentation(Model, "Blocking Model - Actors will not move into this model.")

#pragma GE_Origin(Origin)
} BlockActor;

#pragma warning( default : 4068 )

#endif
